 
/* naide
kontrollib kas  vahe = *(massiiv - *n - 1) - *(massiiv - *n - 2);
    t2idab tingimust ( (*n) + 1 <= 15 && absolute( vahe ) <= e )   
    { kui "ja", siis arvutab 
        v *= (((*n) + 1)*2 - 3)/((double)((*n) + 1)*2 - 2);	
    	double vv = v * power(x, ((*n) + 1)*2 - 1) / ((double)(((*n) + 1))*2 - 1);	ja 
    lisab arvutatud vaartuse massiivi	push(massiiv, n, vv); mis listis
	 ning tuhjendab siis  selle faili  */

#include <stdio.h>
#include <stdlib.h>

typedef struct LIST{
	int loc;
	double v22rtus;
	struct LIST *pNext;
	struct LIST *pPrev;
}LIST;

char outFileName[] = "F.txt";                         // valjundfaili nimi
//=====================================================
void sisestus( double * x , double * e);                 //algandmed
double power(double a , int b);                          //arvutab a^b  , votab arvu a astmele b
double absolute(double value);                           // arvutab absoluutvaartuse
void valjastus(LIST *list);                              // loob faili
LIST *push(LIST *list, double value);                    // lisab stack'i
void rekursiiv(LIST *list, double v, double x, double e);// igal korral saadab edasi eelmise vastuse
//=====================================================
int main( void )
{ double x, e;
	LIST *list = (LIST*)malloc(sizeof(LIST));
	LIST *root = list;
	list->loc = 0;
	list->pPrev = NULL;
    sisestus(&x,&e);
	list = push(list, x);
	
	rekursiiv(list, 1, x, e);
	valjastus(root);

    return 0;
}
void sisestus( double * x , double * e)
{do
    {
        printf("Sisesta reaalarvuline X (|X| < 1): ");
        scanf("%lf",x);
    }while( !(-1 < *x && *x < 1) );
    do
    {printf("Sisesta reaalarvuline e (0 < e < 1): ");
        scanf("%lf", e);
    }while( !( 0 < *e && *e < 1) );
}
double power(double a , int b){  // arvutab a^b  , votab arvu a astmele b
    if( b > 0 )
    {
        return a * power( a, b - 1);
    }
    else return 1;}
double absolute(double value){	// arvutab absoluutvaartuse
    if( value < 0 ) return -1.0f*value;
    else return value;
}

void valjastus(LIST *list)
{
    // loo fail
    FILE * out = fopen( outFileName, "w" );

    while(list->pNext != NULL)
    {
        fprintf(out,"%d) %.15lf\n", list->loc, list->v22rtus);
        list = list->pNext;
    }
    // sulgeme faili
    fclose( out );
}

LIST *push(LIST *list, double value)   // lisab stack'i
{
	LIST *temp = list;
	list->v22rtus = value;
    
    printf("%d) %.15lf\n", list->loc,list->v22rtus); 
	// prindib sisestatud arvu + tema malu aadressi
	list->pNext = (LIST*)malloc(sizeof(LIST));
	list = list->pNext;
	
	list->pPrev = temp;
	list->loc = temp->loc + 1;
	return list;
}
// igal korral saadan edasi eelmise vastuse
void rekursiiv(LIST *list, double v, double x, double e)
{
	if(list->loc == 0 || list->loc == 1)
	{	
	v *= ((list->loc + 1)*2 - 3)/((double)(list->loc + 1)*2 - 2);
		double vv = v * power(x, (list->loc + 1)*2 - 1) / ((double)((list->loc + 1))*2 - 1);
		list = push(list, vv); rekursiiv(list, v, x, e);
		
	}
	else
	{double vahe = list->v22rtus - list->pPrev->v22rtus;
		if(list->loc + 1 <= 15 && absolute(vahe) <= e)
		{
	v *= ((list->loc + 1)*2 - 3)/((double)(list->loc + 1)*2 - 2);
double vv = v *power(x,(list->loc + 1)*2-1)/((double)((list->loc+1))*2- 1);
		list = push(list, vv); rekursiiv(list, v, x, e);
		}else {list->pNext = NULL;
		} }}

